<!-- Copyright (c) 2022 Qualcomm Innovation Center, Inc. All rights reserved. -->
<!-- SPDX-License-Identifier: BSD-3-Clause-Clear -->

<launch>
    <arg name="mapping_mode"  default="gmapping" doc="opt: gmapping,cartographer"/>
    <arg name="navigation" default="false"/>
    <arg name="odom_frame_id"  default="odom_combined"/>

    <include file="$(find turn_on_qti_robot)/launch/qti_lidar.launch" />

    <node pkg="world_canvas_msgs" type="save" name="save_map" />

    <group if="$(eval mapping_mode == 'gmapping')">
        <include file="$(find turn_on_qti_robot)/launch/include/algorithm_gmapping.launch" />
        <include file="$(find turn_on_qti_robot)/launch/turn_on_qti_robot.launch">
            <arg name="navigation" value="$(arg navigation)"/>
            <arg name="is_cartographer" value="false"/>
            <arg name="odom_frame_id"   value="$(arg odom_frame_id)"/>
        </include>
    </group>

    <group if="$(eval mapping_mode == 'cartographer')">
        <include file="$(find cartographer_ros)/launch/demo_revo_lds.launch" />
        <include file="$(find turn_on_qti_robot)/launch/turn_on_qti_robot.launch">
            <arg name="navigation" value="$(arg navigation)"/>
            <arg name="is_cartographer" value="true"/>
        </include>
    </group>
</launch>
